<?php
/**
 * Emerald Payment Plugin by MintJoomla
 * a plugin for Joomla! 1.7 CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * @copyright Copyright (C) 2012 MintJoomla (http://www.mintjoomla.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');

class plgEmeraldPaygoogleco extends JPlugin
{
	
	var $_db = null;

	function plgEmeraldPaygoogleco(& $subject, $config)
	{
		$this->_db = JFactory::getDBO();
		parent::__construct($subject, $config);
	}

	function onReceivePayment(&$post)
	{
		
		if ($post['processor'] != 'paygoogleco')
			return 0;
		$params = new JRegistry($post['params']);
		$default = $this->params;
		
		if ($params->get('params.paygoogleco_errorlog', $default->get('paygoogleco_errorlog')))
			error_log("\n\n[Start get post]: " . print_r($post, true), 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS. 'paygoogleco'. DS . 'log.txt');
		
		$out['sid'] = $post['shopping-cart_items_item-1_merchant-item-id'];
		$out['gateway'] = $post['processor'];
		$out['gateway_id'] = $post['google-order-number'];
		$out['user_id'] = JRequest::getInt('shopping-cart_items_item-1_merchant-private-item-data', $post['shopping-cart_items_item-1_merchant-private-item-data']);
		$out['price'] = JRequest::getVar('order-total', $post['order-total']);
		
		$out['pay'] = 'fail';

		switch ($post['_type'])
		{
			case "new-order-notification" :
					//$out['pay'] = 'success';
				break;
			case "order-state-change-notification" :
				if ($post['new-financial-order-state'] == 'CHARGED')
				{
					$db = JFactory::getDBO();
					$sql = "UPDATE #__jcs_user_subscr SET published = 1 WHERE gateway_id = '" .$out['gateway_id']."'";
					$db->setQuery($sql);
					$db->query();
					JError::raiseNotice(100, JText::_('Your subscription was activated successfully'));
					if ($params->get('params.paygoogleco_errorlog', $default->get('paygoogleco_errorlog')))
						error_log("\n[Updated]: ", 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS. 'paygoogleco'. DS . 'log.txt');
			
				}	
				return;
			
				break;
			default: 
				return ;			
		}
		
		if ($params->get('params.paygoogleco_errorlog', $default->get('paygoogleco_errorlog')))
			error_log("\n[Return out]: " . print_r($out, true), 3, JPATH_ROOT . DS . 'plugins' . DS . 'emerald' . DS. 'paygoogleco'. DS . 'log.txt');
		
		JError::raiseNotice(100, JText::_('Your subscription was created but not activated. It may take some time to get confirmation from Google Checkout.'));
		return $out;
	}

	function onSendPayment(&$post)
	{
		if ($post['processor'] != 'paygoogleco')
			return false;
		$db = & JFactory::getDBO();
		
		$Itemid = JRequest::getInt('Itemid');
		
		$params = new JRegistry($post['params']);
		$default = $this->params;
		
		$param['email'] = isset($post['email']) ? $post['email'] : '';
		$param['option'] = JRequest::getCmd('option');
		$param['task'] = @$post['task'];
		$param['view'] = @$post['view'];
		$param['layout'] = @$post['layout'];
		$param['processor'] = 'paygoogleco';
		$param['Itemid'] = @$Itemid;
		
		$return = JURI::root() . 'index.php?option=' . $param['option'] . '&view=' . $param['view'] . '&layout=' . $param['layout'] . '&plan=' . $post['order_id'] . '&Itemid=' . $Itemid; 
	//	JURI::root() . 'index.php?' . GooChArray2Url($param);// . '&pay=success';
		
		if ($params->get('paygoogleco_print_url', $default->get('paygoogleco_print_url', 0)))
		{
			print "<pre>";
			print_r(JURI::root() . 'index.php?' . GooChArray2Url($param));
			print "</pre>";
			exit();
		}
		
		unset($param);
		$title = explode('::', $post['order_title']);
		$param['item_name_1'] = str_replace('"', '\'', $title[1]); 
		$param['item_description_1'] = str_replace('"', '\'', $post['order_title']); 
		$param['item_quantity_1'] = 1; 
		$param['item_price_1'] = floatval($post['order_amount']);
		$param['item_currency_1'] = $params->get('params.paygoogleco_currency', $default->get('paygoogleco_currency')); 
		
		$param['continue_url'] = $return;		
		 
		$param['_charset_'] = 'utf-8';
	
		$merchant = $params->get('params.paygoogleco_merchant', $default->get('params.paygoogleco_merchant'));
				
		$tax = $params->get('params.paygoogleco_tax', $default->get('paygoogleco_tax'));
		
		if (!$merchant || !$param['item_currency_1'] || !$param['item_name_1'] || !$param['item_price_1'])
		{
			JError::raiseWarning(403, JText::_("Error Payment Processing: some of the params passed are empty"));
			return;
		}
		$url = 'https://checkout.google.com/';
		
		if ($params->get('params.paygoogleco_sandbox', $default->get('paygoogleco_sandbox')))
		{
			$url = 'https://sandbox.google.com/checkout/';
		}
		$url .= 'api/checkout/v2/checkoutForm/Merchant/'.$merchant;//.'?' . GooChArray2Url($param);;		
		
		echo '<form id="googlecoform" method="POST" action="'.$url.'" accept-charset="utf-8">
		  <input type="hidden" name="item_name_1" value="'.$param['item_name_1'].'"/>
		  <input type="hidden" name="item_description_1" value="'.$param['item_description_1'].'"/>
		  <input type="hidden" name="item_price_1" value="'.$param['item_price_1'].'"/>
		  <input type="hidden" name="item_currency_1" value="'.$param['item_currency_1'].'"/>
		  <input type="hidden" name="item_quantity_1" value="1"/>
		  <input type="hidden" name="continue_url" value="'.$return.'"/>
		  <input type="hidden" name="shopping-cart.items.item-1.merchant-item-id" value="'.$post['order_id'].'"/>
		  <input type="hidden" name="shopping-cart.items.item-1.merchant-private-item-data" value="'.$post['user_id'].'"/>'
		  .($tax && ($tax != '0.00' || $tax != '0.0') ? '<input type="hidden" name="tax_rate" value="'.$tax.'"/>' : '')
		.'</form><script>document.getElementById("googlecoform").submit();</script>';
		
	
	}

	function onCheckParams($params)
	{
		if ($params->get('params.paygoogleco_merchant') == '')
			JError::raiseNotice(100, $this->_name . ': ' . JText::_('Merchant ID is not set'));
	}
	
	function OnHistoryShow()
	{
		if(JRequest::getInt('plan'))
			JError::raiseNotice(100, JText::_('Your subscription was created'));
	}

}



function GooChArray2Url($param)
{
	foreach($param as $k => $v)
	{
		if (!$v)
			continue;
		$out[] = "$k=$v";
	}
	return implode('&', $out);
}
?>